/*@ requires \valid(p) && \valid(q);
  assigns *p, *q;
  ensures p_swapped: *p == \at(*q, Pre);
  ensures q_swapped: *q == \at(*p, Pre);
 */
void swap(int* p, int* q) {
  int tmp = *q;
  *q = *p;
  *p = tmp;
}

/*
Local Variables:
compile-command: "frama-c-gui -wp -wp-rte swap_proved.c"
End:
*/

